diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/.eslintrc.js b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/.eslintrc.js
new file mode 100644
index 000000000..e2a7c5b54
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/.eslintrc.js
@@ -0,0 +1,3 @@
+module.exports = {
+  extends: ['rax'],
+};
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/.gitignore b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/.gitignore
new file mode 100644
index 000000000..50a53dace
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/.gitignore
@@ -0,0 +1,17 @@
+# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
+
+*~
+*.swp
+*.log
+
+.DS_Store
+.idea/
+.temp/
+
+build/
+dist/
+lib/
+coverage/
+node_modules/
+
+template.yml
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/app.js b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/app.js
new file mode 100644
index 000000000..bc474c6e3
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/app.js
@@ -0,0 +1,6 @@
+import { runApp } from 'rax-app';
+import appConfig from './app.json';
+
+import './global.scss';
+
+runApp(appConfig);
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/constants.js b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/constants.js
new file mode 100644
index 000000000..ea766c9da
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/constants.js
@@ -0,0 +1,3 @@
+const __$$constants = {};
+
+export default __$$constants;
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/document/index.jsx b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/document/index.jsx
new file mode 100644
index 000000000..50569a9b6
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/document/index.jsx
@@ -0,0 +1,25 @@
+import { createElement } from 'rax';
+import { Root, Style, Script } from 'rax-document';
+
+function Document() {
+  return (
+    <html>
+      <head>
+        <meta charset="utf-8" />
+        <meta
+          name="viewport"
+          content="width=device-width,initial-scale=1,maximum-scale=1,minimum-scale=1,user-scalable=no,viewport-fit=cover"
+        />
+        <title>Rax App Demo</title>
+        <Style />
+      </head>
+      <body>
+        {/* root container */}
+        <Root />
+        <Script />
+      </body>
+    </html>
+  );
+}
+
+export default Document;
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/i18n.js b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/i18n.js
new file mode 100644
index 000000000..c3e7c955d
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/i18n.js
@@ -0,0 +1,38 @@
+import IntlMessageFormat from 'intl-messageformat';
+
+const i18nConfig = {
+  'zh-CN': {
+    'hello-world': '你好，世界！',
+  },
+  'en-US': {
+    'hello-world': 'Hello world!',
+  },
+};
+
+let locale = 'en-US';
+
+const getLocale = () => locale;
+
+const setLocale = (target) => {
+  locale = target;
+};
+
+const i18nFormat = ({ id, defaultMessage }, variables) => {
+  const msg = (i18nConfig && i18nConfig[locale] && i18nConfig[locale][id]) || defaultMessage;
+  if (msg == null) {
+    console.warn('[i18n]: unknown message id: %o (locale=%o)', id, locale);
+    return `${id}`;
+  }
+
+  if (!variables || !variables.length) {
+    return msg;
+  }
+
+  return new IntlMessageFormat(msg, locale).format(variables);
+};
+
+const i18n = (id) => {
+  return i18nFormat({ id });
+};
+
+export { getLocale, setLocale, i18n, i18nFormat };
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/pages/Home/index.jsx b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/pages/Home/index.jsx
new file mode 100644
index 000000000..d7885feb3
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/pages/Home/index.jsx
@@ -0,0 +1,163 @@
+// 注意: 出码引擎注入的临时变量默认都以 "__$$" 开头，禁止在搭建的代码中直接访问。
+// 例外：rax 框架的导出名和各种组件名除外。
+import { createElement, Component } from 'rax';
+import { withRouter as __$$withRouter } from 'rax-app';
+
+import Page from 'rax-view';
+
+import Text from 'rax-text';
+
+import { create as __$$createDataSourceEngine } from '@ali/lowcode-datasource-engine/runtime';
+
+import { isMiniApp as __$$isMiniApp } from 'universal-env';
+
+import __$$constants from '../../constants';
+
+import * as __$$i18n from '../../i18n';
+
+import __$$projectUtils from '../../utils';
+
+import './index.css';
+
+class Home$$Page extends Component {
+  _methods = this._defineMethods();
+
+  _context = this._createContext();
+
+  _dataSourceConfig = this._defineDataSourceConfig();
+  _dataSourceEngine = __$$createDataSourceEngine(this._dataSourceConfig, this._context, { runtimeConfig: true });
+
+  _utils = this._defineUtils();
+
+  componentDidMount() {
+    this._dataSourceEngine.reloadDataSource();
+  }
+
+  componentWillUnmount() {}
+
+  render() {
+    const __$$context = this._context;
+    const {
+      state,
+      setState,
+      dataSourceMap,
+      reloadDataSource,
+      utils,
+      constants,
+      i18n,
+      i18nFormat,
+      getLocale,
+      setLocale,
+    } = __$$context;
+
+    return (
+      <Page>
+        <Text
+          onClick={function () {
+            __$$context.setLocale(__$$context.getLocale() === 'en-US' ? 'zh-CN' : 'en-US');
+          }}
+        >
+          {__$$eval(() => __$$context.i18n['hello-world'])}
+        </Text>
+      </Page>
+    );
+  }
+
+  _createContext() {
+    const self = this;
+
+    // 保存下最新的状态，这样 setState 可以搞成同步一样的了
+    self._latestState = self.state;
+
+    const context = {
+      get state() {
+        // 这里直接获取最新的 state，从而能避免一些 React/Rax 这样的框架因为异步 setState 而导致的一些问题
+        return self._latestState;
+      },
+      setState(newState) {
+        self._latestState = { ...self._latestState, ...newState };
+        self.setState(newState);
+      },
+      get dataSourceMap() {
+        return self._dataSourceEngine.dataSourceMap || {};
+      },
+      async reloadDataSource() {
+        await self._dataSourceEngine.reloadDataSource();
+      },
+      get utils() {
+        return self._utils;
+      },
+      get page() {
+        return context;
+      },
+      get component() {
+        return context;
+      },
+      get props() {
+        return self.props;
+      },
+      get constants() {
+        return __$$constants;
+      },
+      i18n: __$$i18n.i18n,
+      i18nFormat: __$$i18n.i18nFormat,
+      getLocale: __$$i18n.getLocale,
+      setLocale(locale) {
+        __$$i18n.setLocale(locale);
+        self.forceUpdate();
+      },
+      ...this._methods,
+    };
+
+    return context;
+  }
+
+  _defineDataSourceConfig() {
+    const __$$context = this._context;
+    return { list: [] };
+  }
+
+  _defineUtils() {
+    const utils = {
+      ...__$$projectUtils,
+    };
+
+    Object.entries(utils).forEach(([name, util]) => {
+      if (typeof util === 'function') {
+        utils[name] = util.bind(this._context);
+      }
+    });
+
+    return utils;
+  }
+
+  _defineMethods() {
+    const __$$methods = {};
+
+    // 为所有的方法绑定上下文
+    Object.entries(__$$methods).forEach(([methodName, method]) => {
+      if (typeof method === 'function') {
+        __$$methods[methodName] = (...args) => {
+          return method.apply(this._context, args);
+        };
+      }
+    });
+
+    return __$$methods;
+  }
+}
+
+export default __$$withRouter(Home$$Page);
+
+function __$$eval(expr) {
+  try {
+    return expr();
+  } catch (err) {
+    console.warn('Failed to evaluate: ', expr, err);
+  }
+}
+
+function __$$evalArray(expr) {
+  const res = __$$eval(expr);
+  return Array.isArray(res) ? res : [];
+}
diff --git a/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/utils.js b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/utils.js
new file mode 100644
index 000000000..ff8b4c563
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/expected/demo-project/src/utils.js
@@ -0,0 +1 @@
+export default {};
diff --git a/packages/code-generator/test-cases/rax-app/demo5/schema.json5 b/packages/code-generator/test-cases/rax-app/demo5/schema.json5
new file mode 100644
index 000000000..3c767dfd9
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo5/schema.json5
@@ -0,0 +1,73 @@
+{
+  // 这是一个关于国际化的 schema 示例
+  // Schema 参见：https://yuque.antfin-inc.com/mo/spec/spec-materials#eNCJr
+  version: '1.0.0',
+  componentsMap: [
+    {
+      componentName: 'Page',
+      package: 'rax-view',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Page',
+    },
+    {
+      componentName: 'Text',
+      package: 'rax-text',
+      version: '^1.0.0',
+      destructuring: false,
+      exportName: 'Text',
+    },
+  ],
+  componentsTree: [
+    {
+      componentName: 'Page',
+      props: {},
+      lifeCycles: {},
+      fileName: 'home',
+      meta: {
+        router: '/',
+      },
+      dataSource: {
+        list: [],
+      },
+      children: [
+        {
+          componentName: 'Text',
+          props: {
+            onClick: {
+              type: 'JSFunction',
+              value: "function () {\n  this.setLocale(this.getLocale() === 'en-US' ? 'zh-CN' : 'en-US');\n}",
+            },
+          },
+          children: [
+            {
+              type: 'JSExpression',
+              value: 'this.i18n["hello-world"]',
+            },
+          ],
+        },
+      ],
+    },
+  ],
+  i18n: {
+    'zh-CN': {
+      'hello-world': '你好，世界！',
+    },
+    'en-US': {
+      'hello-world': 'Hello world!',
+    },
+  },
+  config: {
+    sdkVersion: '1.0.3',
+    historyMode: 'hash',
+    targetRootID: 'root',
+  },
+  meta: {
+    name: 'Rax App Demo',
+    git_group: 'demo-group',
+    project_name: 'demo-project',
+    description: '这是一个示例应用',
+    spma: 'spmademo',
+    creator: '张三',
+  },
+}
diff --git a/packages/code-generator/test/rax-app.test.ts b/packages/code-generator/test/rax-app.test.ts
new file mode 100644
index 000000000..c7ce4c5c8
--- /dev/null
+++ b/packages/code-generator/test/rax-app.test.ts
@@ -0,0 +1,118 @@
+import test from 'ava';
+import { spawnSync } from 'child_process';
+import fs from 'fs';
+import glob from 'glob';
+import JSON from 'json5';
+import path from 'path';
+import chalk from 'chalk';
+import type { ProjectSchema } from '@ali/lowcode-types';
+
+import CodeGenerator from '../src';
+
+const TEST_CASES_DIR = path.join(__dirname, '../test-cases/rax-app');
+
+getSubDirectoriesSync(TEST_CASES_DIR).forEach(defineTest);
+
+function defineTest(caseDirName: string) {
+  test(`rax-app ${caseDirName} should works`, async (t) => {
+    const caseFullDir = path.join(TEST_CASES_DIR, caseDirName);
+    const schema = JSON.parse(fs.readFileSync(path.join(caseFullDir, 'schema.json5'), 'utf-8'));
+    const actualDir = path.join(caseFullDir, 'actual');
+
+    removeActualDirRecursiveSync(actualDir, caseFullDir);
+
+    await exportProject(schema, actualDir, 'demo-project');
+
+    const actualFiles = glob.sync('**/*.{js,jsx,json,ts,tsx,less,css,scss,sass}', { cwd: actualDir });
+
+    t.true(actualFiles.length > 0);
+
+    runPrettierSync(actualFiles, actualDir);
+
+    const differences = diffActualAndExpectedSync(caseFullDir);
+    if (differences) {
+      t.fail(differences);
+    }
+  });
+}
+
+async function exportProject(schemaJson: ProjectSchema, targetPath: string, projectName: string) {
+  const raxAppBuilder = CodeGenerator.solutions.rax();
+  const result = await raxAppBuilder.generateProject(schemaJson);
+  const publisher = CodeGenerator.publishers.disk();
+  await publisher.publish({
+    project: result,
+    outputPath: targetPath,
+    projectSlug: projectName,
+    createProjectFolder: true,
+  });
+}
+
+function removeActualDirRecursiveSync(actualDir: string, caseFullDir: string) {
+  ensureShellExec('rm', ['-rf', actualDir], { cwd: caseFullDir });
+}
+
+function runPrettierSync(files: string[], cwd: string) {
+  ensureShellExec('npx', ['prettier', '--write', ...files], { cwd });
+}
+
+function diffActualAndExpectedSync(caseFullDir: string): string {
+  const res = spawnSync('diff', ['-wBur', 'expected', 'actual'], {
+    cwd: caseFullDir,
+    stdio: 'pipe',
+    shell: true,
+    encoding: 'utf-8',
+  });
+
+  return colorizeDiffOutput(res.stdout);
+}
+
+function ensureShellExec(
+  shellCmd: string,
+  args: string[],
+  { cwd = process.cwd() }: { cwd?: string } = {},
+): { stdout: string; stderr: string } {
+  const res = spawnSync(shellCmd, args, {
+    stdio: 'pipe',
+    shell: true,
+    cwd,
+    encoding: 'utf-8',
+  });
+
+  if (res.status !== 0) {
+    throw new Error(
+      `Shell command "${shellCmd} ${args.slice(0, 2).join(' ')}..." failed with status: ${
+        res.status
+      } (Full command: "${shellCmd} ${args.join(' ')}" )`,
+    );
+  }
+
+  return res;
+}
+
+function colorizeDiffOutput(output: string): string {
+  if (!output) {
+    return output;
+  }
+
+  return output
+    .split('\n')
+    .map((line) => {
+      if (/^Only/i.test(line)) {
+        return chalk.red(line);
+      } else if (line[0] === '+') {
+        return chalk.yellow(line);
+      } else if (line[0] === '-') {
+        return chalk.red(line);
+      } else {
+        return line;
+      }
+    })
+    .join('\n');
+}
+
+function getSubDirectoriesSync(baseDir: string) {
+  return fs
+    .readdirSync(baseDir)
+    .filter((dirOrFileName: string) => fs.statSync(path.join(baseDir, dirOrFileName)).isDirectory());
+}
diff --git a/packages/code-generator/test/utils/expressionParser/parseExpressionConvertThis2Context.test.ts b/packages/code-generator/test/utils/expressionParser/parseExpressionConvertThis2Context.test.ts
new file mode 100644
index 000000000..19c2b9621
--- /dev/null
+++ b/packages/code-generator/test/utils/expressionParser/parseExpressionConvertThis2Context.test.ts
@@ -0,0 +1,79 @@
+import test from 'ava';
+import type { ExecutionContext, Macro } from 'ava';
+import { parseExpressionConvertThis2Context } from '../../../src/utils/expressionParser';
+
+const macro: Macro<any[]> = (
+  t: ExecutionContext<Record<string, unknown>>,
+  input: [string, string, string[]],
+  expected: string,
+  error?: { message: RegExp },
+) => {
+  if (!error) {
+    t.deepEqual(parseExpressionConvertThis2Context(input[0], input[1], input[2]), expected);
+  } else {
+    t.throws(() => {
+      t.deepEqual(parseExpressionConvertThis2Context(input[0], input[1], input[2]), expected);
+    }, error.message);
+  }
+};
+
+macro.title = (providedTitle: string | undefined, ...args: any[]): string => {
+  const [input, expected] = args;
+  return providedTitle || `after convert this to context "${input[0]}" should be "${expected}"`.replace(/\n|\s+/g, ' ');
+};
+
+test(macro, ['this.hello', '__$$context', []], '__$$context.hello');
+test(macro, ['this.utils.recordEvent', '__$$context', []], '__$$context.utils.recordEvent');
+
+test(
+  macro,
+  ['this.utils.recordEvent.bind(this)', '__$$context', []],
+  '__$$context.utils.recordEvent.bind(__$$context)',
+);
+
+test(macro, ['this.item', '__$$context', ['item']], 'item');
+
+test(macro, ['this.user.name', '__$$context', ['user']], 'user.name');
+
+test(macro, ['function (){}', '__$$context', []], 'function () {}');
+
+test(
+  macro,
+  ['function (){ this.utils.Toast.show("Hello world!") }', '__$$context'],
+  'function () {\n  __$$context.utils.Toast.show("Hello world!");\n}',
+);
+
+// 变量能被替换掉
+test(
+  macro,
+  ['function (){ this.utils.recordEvent("click", this.item) }', '__$$context', ['item']],
+  'function () {\n  __$$context.utils.recordEvent("click", item);\n}',
+);
+
+// 只替换顶层的，不替换内层
+test(
+  macro,
+  ['function (){ return function (){ this.utils.recordEvent("click", this.item) } }', '__$$context', ['item']],
+  'function () {\n  return function () {\n    this.utils.recordEvent("click", item);\n  };\n}',
+);
+
+// 只替换顶层的，不替换内层
+test(
+  macro,
+  ['function onClick(){ return function (){ this.utils.recordEvent("click", this.item) } }', '__$$context', ['item']],
+  'function onClick() {\n  return function () {\n    this.utils.recordEvent("click", item);\n  };\n}',
+);
+
+// 只替换顶层的，不替换内层
+test(
+  macro,
+  ['() => { return function (){ this.utils.recordEvent("click", this.item) } }', '__$$context', ['item']],
+  '() => {\n  return function () {\n    this.utils.recordEvent("click", item);\n  };\n}',
+);
+
+// 但是若内层有用箭头函数定义的则还是要替换下
+test(
+  macro,
+  ['() => { return () => { this.utils.recordEvent("click", this.item) } }', '__$$context', ['item']],
+  '() => {\n  return () => {\n    __$$context.utils.recordEvent("click", item);\n  };\n}',
+);
diff --git a/packages/code-generator/test/utils/expressionParser/parseExpressionGetGlobalVariables.test.ts b/packages/code-generator/test/utils/expressionParser/parseExpressionGetGlobalVariables.test.ts
new file mode 100644
index 000000000..e7c6f3cae
--- /dev/null
+++ b/packages/code-generator/test/utils/expressionParser/parseExpressionGetGlobalVariables.test.ts
@@ -0,0 +1,114 @@
+import test from 'ava';
+import type { ExecutionContext, Macro } from 'ava';
+import {
+  parseExpressionGetGlobalVariables,
+  ParseExpressionGetGlobalVariablesOptions,
+} from '../../../src/utils/expressionParser';
+
+const macro: Macro<any[]> = (
+  t: ExecutionContext<Record<string, unknown>>,
+  input: [string | null | undefined, ParseExpressionGetGlobalVariablesOptions],
+  expected: string[],
+  error?: { message: RegExp },
+) => {
+  if (!error) {
+    t.deepEqual(parseExpressionGetGlobalVariables(input[0], input[1]), expected);
+  } else {
+    t.throws(() => {
+      t.deepEqual(parseExpressionGetGlobalVariables(input[0], input[1]), expected);
+    }, error.message);
+  }
+};
+
+macro.title = (providedTitle: string | undefined, ...args: any[]): string => {
+  const [input, expected] = args;
+  return providedTitle || `global variables of "${input[0]}" should be "${expected.join(', ')}"`;
+};
+
+test(macro, ['function (){ }', {}], []);
+test(macro, ['function (){ __$$context.utils.Toast.show("Hello world!") }', {}], ['__$$context']);
+
+test(macro, ['function (){ __$$context.utils.formatPrice(item.price1, "元") }', {}], ['__$$context', 'item']);
+
+test(
+  macro,
+  [
+    'function (){ __$$context.utils.formatPrice(item2, "元"); }',
+    { filter: (varName: string) => !/^__\$\$/.test(varName) },
+  ],
+  ['item2'],
+);
+
+test(
+  macro,
+  [
+    'function (){ __$$context.utils.log(item3, [item4, item5]); }',
+    { filter: (varName: string) => !/^__\$\$/.test(varName) },
+  ],
+  ['item3', 'item4', 'item5'],
+);
+
+test(
+  macro,
+  ['function (){ item3[item4]("Hello"); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['item3', 'item4'],
+);
+
+test(macro, ['function (){ item3("Hello"); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }], ['item3']);
+
+test(
+  macro,
+  ['function foo(){ foo[item3]("Hello"); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['item3'],
+);
+
+// isAssignmentExpression/right
+test(
+  macro,
+  ['function (){ let foo; foo = item3; foo(); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['item3'],
+);
+
+// isAssignmentExpression/left
+test(
+  macro,
+  ['function (){ foo = item3; foo(); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['foo', 'item3'],
+);
+
+// isVariableDeclarator
+test(
+  macro,
+  ['function (){ const foo = item3; foo(); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['item3'],
+);
+
+// isVariableDeclarator
+test(
+  macro,
+  ['function (){ let foo = item3; foo(); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['item3'],
+);
+
+// isVariableDeclarator
+test(
+  macro,
+  ['function (){ var foo = item3; foo(); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['item3'],
+);
+
+// isTemplateLiteral
+test(
+  macro,
+  ['function (){ console.log(`Hello ${item3};`); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['console', 'item3'],
+);
+
+// isBinaryExpression
+test(
+  macro,
+  ['function (){ console.log(item2 | item3); }', { filter: (varName: string) => !/^__\$\$/.test(varName) }],
+  ['console', 'item2', 'item3'],
+);
+
+// TODO: 补充更多类型的测试用例
diff --git a/packages/code-generator/test/utils/version.test.ts b/packages/code-generator/test/utils/version.test.ts
new file mode 100644
index 000000000..f3a3fba74
--- /dev/null
+++ b/packages/code-generator/test/utils/version.test.ts
@@ -0,0 +1,50 @@
+import test from 'ava';
+import type { ExecutionContext, Macro } from 'ava';
+import { calcCompatibleVersion } from '../../src/utils/version';
+
+const NO_COMPATIBLE_VERSIONS = /no compatible versions/;
+
+const testCalcCompatibleVersion: Macro<any[]> = (
+  t: ExecutionContext<Record<string, unknown>>,
+  input: [string | null | undefined, string | null | undefined],
+  expected: string,
+  error?: { message: RegExp },
+) => {
+  if (!error) {
+    t.is(calcCompatibleVersion(input[0], input[1]), expected);
+    t.is(calcCompatibleVersion(input[1], input[0]), expected); // 应该满足交换律
+  } else {
+    t.throws(() => {
+      calcCompatibleVersion(input[0], input[1]);
+    }, error.message);
+    t.throws(() => {
+      calcCompatibleVersion(input[1], input[0]); // 应该满足交换律
+    }, error.message);
+  }
+};
+
+testCalcCompatibleVersion.title = (providedTitle: string | undefined, ...args: any[]): string => {
+  const [input, expected] = args;
+  return `calc compatible versions "${input[0]}" & "${input[1]}" should be "${expected}"`;
+};
+
+test(testCalcCompatibleVersion, ['*', '*'], '*');
+test(testCalcCompatibleVersion, ['1.0.0', '1.0.0'], '1.0.0');
+test(testCalcCompatibleVersion, ['^1.0.0', '^1.0.0'], '^1.0.0');
+
+test(testCalcCompatibleVersion, ['*', undefined], '*');
+
+test(testCalcCompatibleVersion, [undefined, undefined], '*');
+
+test(testCalcCompatibleVersion, ['^1.0.0', undefined], '^1.0.0');
+
+test(testCalcCompatibleVersion, ['*', '^1.0.0'], '^1.0.0');
+test(testCalcCompatibleVersion, ['^1.0.0', '^1.0.2'], '^1.0.2');
+test(testCalcCompatibleVersion, ['^1.2.0', '^1.1.2'], '^1.2.0');
+test(testCalcCompatibleVersion, ['^1.0.0', '1.0.2'], '1.0.2');
+
+test(testCalcCompatibleVersion, ['^0.2.0', '^0.1.2'], 'error', { message: NO_COMPATIBLE_VERSIONS });
+
+test(testCalcCompatibleVersion, ['>0.2.0', '^0.1.2'], 'error', { message: NO_COMPATIBLE_VERSIONS });
+
+test(testCalcCompatibleVersion, ['1.0.1', '1.0.2'], 'error', { message: NO_COMPATIBLE_VERSIONS });
diff --git a/packages/code-generator/tools/createTemplate.js b/packages/code-generator/tools/createTemplate.js
index 8b4a47215..3a10b1599 100644
--- a/packages/code-generator/tools/createTemplate.js
+++ b/packages/code-generator/tools/createTemplate.js
@@ -2,13 +2,13 @@ const fs = require('fs');
 const path = require('path');
 
 console.log(process.argv);
-let root = '';
+let rootPath = '';
 const pathArgIndex = process.argv.indexOf('--path');
 if (pathArgIndex >= 0) {
-  root = process.argv[pathArgIndex + 1];
+  rootPath = process.argv[pathArgIndex + 1];
 }
 
-if (!root) {
+if (!rootPath) {
   throw new Error('Can\'t find path argument');
 }
 
@@ -35,7 +35,7 @@ function createTemplateFile(root, internalPath, fileName) {
     encoding: 'utf8',
   });
   const pathList = (internalPath.split(path.sep) || []).filter(p => !!p);
-  const modulePathStr = JSON.stringify(pathList).replace(/\"/g, '\'');
+  const modulePathStr = JSON.stringify(pathList).replace(/"/g, '\'');
 
   const templateContent = `
 import ResultFile from '${depPrefix}model/ResultFile';
@@ -80,6 +80,6 @@ function fileDisplay(root, internalPath) {
 
 // 调用函数遍历根目录，同时传递 文件夹路径和对应的数组
 // 请使用同步读取
-fileDisplay(root, '');
+fileDisplay(rootPath, '');
 // 读取完毕则写入到txt文件中
 // fs.writeFileSync('./data.txt', JSON.stringify(arr));
diff --git a/packages/datasource-engine/.gitignore b/packages/datasource-engine/.gitignore
new file mode 100644
index 000000000..28b6557db
--- /dev/null
+++ b/packages/datasource-engine/.gitignore
@@ -0,0 +1,5 @@
+/node_modules/
+*.log
+.DS_Store
+/es/
+/lib/
diff --git a/packages/datasource-engine/handlers/fetch/index.d.ts b/packages/datasource-engine/handlers/fetch/index.d.ts
new file mode 100644
index 000000000..86829236a
--- /dev/null
+++ b/packages/datasource-engine/handlers/fetch/index.d.ts
@@ -0,0 +1 @@
+export type * from '../../es/handlers/fetch';
diff --git a/packages/datasource-engine/handlers/fetch/index.js b/packages/datasource-engine/handlers/fetch/index.js
new file mode 100644
index 000000000..5abed6279
--- /dev/null
+++ b/packages/datasource-engine/handlers/fetch/index.js
@@ -0,0 +1 @@
+module.exports = require('../../lib/handlers/fetch').default;
diff --git a/packages/datasource-engine/handlers/mtop/index.d.ts b/packages/datasource-engine/handlers/mtop/index.d.ts
new file mode 100644
index 000000000..1d11c303b
--- /dev/null
+++ b/packages/datasource-engine/handlers/mtop/index.d.ts
@@ -0,0 +1 @@
+export type * from '../../es/handlers/mtop';
diff --git a/packages/datasource-engine/handlers/mtop/index.js b/packages/datasource-engine/handlers/mtop/index.js
new file mode 100644
index 000000000..89f131c78
--- /dev/null
+++ b/packages/datasource-engine/handlers/mtop/index.js
@@ -0,0 +1 @@
+module.exports = require('../../lib/handlers/mtop').default;
diff --git a/packages/datasource-engine/handlers/url-params/index.d.ts b/packages/datasource-engine/handlers/url-params/index.d.ts
new file mode 100644
index 000000000..58e059ec8
--- /dev/null
+++ b/packages/datasource-engine/handlers/url-params/index.d.ts
@@ -0,0 +1 @@
+export type * from '../../es/handlers/url-params';
diff --git a/packages/datasource-engine/handlers/url-params/index.js b/packages/datasource-engine/handlers/url-params/index.js
new file mode 100644
index 000000000..f9b01c61e
--- /dev/null
+++ b/packages/datasource-engine/handlers/url-params/index.js
@@ -0,0 +1 @@
+module.exports = require('../../lib/handlers/url-params').default;
diff --git a/packages/datasource-engine/src/core/DataSourceEngine.ts b/packages/datasource-engine/src/core/DataSourceEngine.ts
new file mode 100644
index 000000000..1d15aeee1
--- /dev/null
+++ b/packages/datasource-engine/src/core/DataSourceEngine.ts
@@ -0,0 +1,121 @@
+import {
+  DataSourceConfig,
+  DataSourceEngineOptions,
+  IDataSourceEngine,
+  IDataSourceEngineFactory,
+  IRuntimeContext,
+} from '../types';
+import { RuntimeDataSource } from './RuntimeDataSource';
+
+export class DataSourceEngine implements IDataSourceEngine {
+  private _dataSourceMap: Record<string, RuntimeDataSource> = {};
+
+  constructor(
+    private _dataSourceConfig: DataSourceConfig,
+    private _runtimeContext: IRuntimeContext,
+    private _options?: DataSourceEngineOptions,
+  ) {
+    _dataSourceConfig.list?.forEach((ds) => {
+      // 确保数据源都有处理器
+      const requestHandler = ds.requestHandler || _options?.requestHandlersMap?.[ds.type];
+      if (!requestHandler) {
+        throw new Error(`No request handler for "${ds.type}" data source`);
+      }
+
+      this._dataSourceMap[ds.id] = new RuntimeDataSource(
+        ds.id,
+        ds.type,
+        getValue(ds.options) || {},
+        requestHandler.bind(_runtimeContext),
+        ds.dataHandler ? ds.dataHandler.bind(_runtimeContext) : undefined,
+        (data) => {
+          _runtimeContext.setState({ [ds.id]: data });
+        },
+      );
+    });
+  }
+
+  public get dataSourceMap() {
+    return this._dataSourceMap;
+  }
+
+  public async reloadDataSource() {
+    try {
+      const allDataSourceConfigList = this._dataSourceConfig.list || [];
+
+      // urlParams 类型的优先加载
+      for (const ds of allDataSourceConfigList) {
+        if (ds.type === 'urlParams' && (getValue(ds.isInit) ?? true)) {
+          await this._dataSourceMap[ds.id].load();
+        }
+      }
+
+      // 然后是所有其他的
+      const remainDataSourceConfigList = allDataSourceConfigList.filter((x) => x.type !== 'urlParams');
+
+      // 先发起异步的
+      const asyncLoadings: Array<Promise<unknown>> = [];
+      for (const ds of remainDataSourceConfigList) {
+        if (getValue(ds.isInit) ?? true) {
+          const options = getValue(ds.options);
+          if (options && !options.isSync) {
+            this._dataSourceMap[ds.id].setOptions(options);
+            asyncLoadings.push(this._dataSourceMap[ds.id].load(options?.params).catch(() => {}));
+          }
+        }
+      }
+
+      try {
+        // 再按先后顺序发起同步请求
+        for (const ds of remainDataSourceConfigList) {
+          if (getValue(ds.isInit) ?? true) {
+            const options = getValue(ds.options);
+            if (options && options.isSync) {
+              this._dataSourceMap[ds.id].setOptions(options);
+              await this._dataSourceMap[ds.id].load(options?.params);
+              await sleep(0); // TODO: 如何优雅地解决 setState 的异步问题？
+            }
+          }
+        }
+      } catch (e) {}
+
+      await Promise.all(asyncLoadings);
+    } finally {
+      const allDataHandler = this._dataSourceConfig.dataHandler;
+      if (allDataHandler) {
+        await allDataHandler(this._getDataMapOfAll());
+      }
+    }
+  }
+
+  private _getDataMapOfAll(): Record<string, unknown> {
+    const dataMap: Record<string, unknown> = {};
+
+    Object.entries(this._dataSourceMap).forEach(([dsId, ds]) => {
+      dataMap[dsId] = ds.data;
+    });
+
+    return dataMap;
+  }
+}
+
+export const create: IDataSourceEngineFactory['create'] = (dataSourceConfig, runtimeContext, options) => {
+  return new DataSourceEngine(dataSourceConfig, runtimeContext, options);
+};
+
+function getValue<T>(valueOrValueGetter: T | (() => T)): T;
+function getValue<T extends boolean>(valueOrValueGetter: T | (() => T)): T | undefined {
+  if (typeof valueOrValueGetter === 'function') {
+    try {
+      return valueOrValueGetter();
+    } catch (e) {
+      return undefined;
+    }
+  } else {
+    return valueOrValueGetter;
+  }
+}
+
+function sleep(ms: number = 0) {
+  return new Promise((resolve) => setTimeout(resolve, ms));
+}
